searchData={"items":[{"type":"module","title":"ElementTui","doc":"Main interface to the ElementTui library, for running a terminal user interface (TUI). Functions in this module allow parsing\nelements and rendering them to the screen. The function `run_loop/3` is a good starting point for running a TUI loop.\n\nTo see the type of elements that can be rendered, check the `ElementTui.Element` module documentation and struct. Also check the\nexamples repository: [https://codeberg.org/edwinvanl/elementtui_examples](https://codeberg.org/edwinvanl/elementtui_examples)","ref":"ElementTui.html"},{"type":"function","title":"ElementTui.height/0","doc":"The height of the terminal","ref":"ElementTui.html#height/0"},{"type":"function","title":"ElementTui.present/0","doc":"Draw the content to the terminal","ref":"ElementTui.html#present/0"},{"type":"function","title":"ElementTui.render/6","doc":"Render the passed elements to a window starting at column x and row y, with total width and height\n\nWill clear the region before rendering.","ref":"ElementTui.html#render/6"},{"type":"function","title":"ElementTui.run_loop/3","doc":"Create a loop for your TUI. Allows passing along state and a function. The function will be called with the state and the event.\n\nAlso possible to pass a timeout, which will be used for polling.","ref":"ElementTui.html#run_loop/3"},{"type":"function","title":"ElementTui.width/0","doc":"The width of the terminal","ref":"ElementTui.html#width/0"},{"type":"module","title":"ElementTui.Application","doc":"Opens a window (tb_init) and kills it on shutdown (tb_shutdown)","ref":"ElementTui.Application.html"},{"type":"module","title":"ElementTui.Element","doc":"Elements are the core of the TUI layout. Importantly they are composable so that you can build complex layouts from simple elements.\n\n```\n# Create a text element with width 10\nElement.text(\"Hello\") |> Element.width(10)\n```","ref":"ElementTui.Element.html"},{"type":"function","title":"ElementTui.Element.blank/0","doc":"","ref":"ElementTui.Element.html#blank/0"},{"type":"function","title":"ElementTui.Element.blank_line/0","doc":"","ref":"ElementTui.Element.html#blank_line/0"},{"type":"function","title":"ElementTui.Element.bold/1","doc":"","ref":"ElementTui.Element.html#bold/1"},{"type":"function","title":"ElementTui.Element.border/1","doc":"","ref":"ElementTui.Element.html#border/1"},{"type":"function","title":"ElementTui.Element.center/1","doc":"","ref":"ElementTui.Element.html#center/1"},{"type":"function","title":"ElementTui.Element.dim/1","doc":"","ref":"ElementTui.Element.html#dim/1"},{"type":"function","title":"ElementTui.Element.focus/1","doc":"","ref":"ElementTui.Element.html#focus/1"},{"type":"function","title":"ElementTui.Element.hbox/1","doc":"","ref":"ElementTui.Element.html#hbox/1"},{"type":"function","title":"ElementTui.Element.height/3","doc":"","ref":"ElementTui.Element.html#height/3"},{"type":"function","title":"ElementTui.Element.hfill/1","doc":"","ref":"ElementTui.Element.html#hfill/1"},{"type":"function","title":"ElementTui.Element.invert_colour/1","doc":"","ref":"ElementTui.Element.html#invert_colour/1"},{"type":"function","title":"ElementTui.Element.layerbox/1","doc":"Plot multiple layers on top of each other. Ensures that the layers are drawn in the correct order.","ref":"ElementTui.Element.html#layerbox/1"},{"type":"function","title":"ElementTui.Element.margin/2","doc":"","ref":"ElementTui.Element.html#margin/2"},{"type":"function","title":"ElementTui.Element.pad/1","doc":"","ref":"ElementTui.Element.html#pad/1"},{"type":"function","title":"ElementTui.Element.render/1","doc":"","ref":"ElementTui.Element.html#render/1"},{"type":"function","title":"ElementTui.Element.text/1","doc":"","ref":"ElementTui.Element.html#text/1"},{"type":"function","title":"ElementTui.Element.vbox/2","doc":"Opts can contain scroll: true","ref":"ElementTui.Element.html#vbox/2"},{"type":"function","title":"ElementTui.Element.vfill/1","doc":"","ref":"ElementTui.Element.html#vfill/1"},{"type":"function","title":"ElementTui.Element.width/2","doc":"","ref":"ElementTui.Element.html#width/2"},{"type":"function","title":"ElementTui.Element.wrap/1","doc":"","ref":"ElementTui.Element.html#wrap/1"},{"type":"module","title":"ElementTui.Parser","doc":"","ref":"ElementTui.Parser.html"},{"type":"function","title":"ElementTui.Parser.calculate_dim/3","doc":"","ref":"ElementTui.Parser.html#calculate_dim/3"},{"type":"function","title":"ElementTui.Parser.parse/5","doc":"","ref":"ElementTui.Parser.html#parse/5"},{"type":"module","title":"ElementTui.TermBox2Ex","doc":"Thin wrapper around the termbox2 C library. In general a user should not need to use this directly, but instead use the main ElementTui module.","ref":"ElementTui.TermBox2Ex.html"},{"type":"function","title":"ElementTui.TermBox2Ex.clear/0","doc":"","ref":"ElementTui.TermBox2Ex.html#clear/0"},{"type":"function","title":"ElementTui.TermBox2Ex.clear_region/4","doc":"","ref":"ElementTui.TermBox2Ex.html#clear_region/4"},{"type":"function","title":"ElementTui.TermBox2Ex.ex_start/0","doc":"","ref":"ElementTui.TermBox2Ex.html#ex_start/0"},{"type":"function","title":"ElementTui.TermBox2Ex.ex_stop/0","doc":"","ref":"ElementTui.TermBox2Ex.html#ex_stop/0"},{"type":"function","title":"ElementTui.TermBox2Ex.height/0","doc":"","ref":"ElementTui.TermBox2Ex.html#height/0"},{"type":"function","title":"ElementTui.TermBox2Ex.load_nifs/0","doc":"","ref":"ElementTui.TermBox2Ex.html#load_nifs/0"},{"type":"function","title":"ElementTui.TermBox2Ex.poll/1","doc":"","ref":"ElementTui.TermBox2Ex.html#poll/1"},{"type":"function","title":"ElementTui.TermBox2Ex.present/0","doc":"","ref":"ElementTui.TermBox2Ex.html#present/0"},{"type":"function","title":"ElementTui.TermBox2Ex.puts/4","doc":"","ref":"ElementTui.TermBox2Ex.html#puts/4"},{"type":"function","title":"ElementTui.TermBox2Ex.so_contents/0","doc":"","ref":"ElementTui.TermBox2Ex.html#so_contents/0"},{"type":"function","title":"ElementTui.TermBox2Ex.width/0","doc":"","ref":"ElementTui.TermBox2Ex.html#width/0"},{"type":"module","title":"ElementTui.Tui","doc":"This genserver will be started by the application. It will also handle drawing, in order to make sure we write single threaded.","ref":"ElementTui.Tui.html"},{"type":"function","title":"ElementTui.Tui.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ElementTui.Tui.html#child_spec/1"},{"type":"function","title":"ElementTui.Tui.clear_region/4","doc":"","ref":"ElementTui.Tui.html#clear_region/4"},{"type":"function","title":"ElementTui.Tui.get_input_buffer/0","doc":"","ref":"ElementTui.Tui.html#get_input_buffer/0"},{"type":"function","title":"ElementTui.Tui.input/2","doc":"","ref":"ElementTui.Tui.html#input/2"},{"type":"function","title":"ElementTui.Tui.poll/1","doc":"","ref":"ElementTui.Tui.html#poll/1"},{"type":"function","title":"ElementTui.Tui.present/0","doc":"","ref":"ElementTui.Tui.html#present/0"},{"type":"function","title":"ElementTui.Tui.puts/4","doc":"","ref":"ElementTui.Tui.html#puts/4"},{"type":"function","title":"ElementTui.Tui.start_link/1","doc":"","ref":"ElementTui.Tui.html#start_link/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}